/*
#################################################################################
#####################################MH Steps####################################
#################################################################################
*/
/*
############
##MH for R##
############
*/

double MHR(double phi,int* mR,double* mX,double* mY,double c,double d,double delta,double* mGam,double* mOm1,double* mOm2,double e,double f,arma::icolvec *Rout,double add0,double add1,int* mXI,arma::mat Hs,arma::vec countnotwo,int nR,int choiceg,int selectioncgh,int m,int mg, int g, int nOss)
{
arma::icolvec R(mR,mg,false);
arma::icolvec Rnew(mg);
Rnew=R;
int* mRnew=Rnew.memptr();
int acc=0;
double piRxi=0;
int chg;
int choice;
int choice1;
int choice2;
arma::ivec flag(mg); 
int* mFlag=flag.memptr(); 
    
//Choose between Adding/Deleting or Swap step
double x= rand()/(double(RAND_MAX)+1);
chg=choiceg*m;

//zeros are the zero position in R, ones are the one position in R, countz number of zeros and counto number of ones
arma::uvec ones = find(R.rows(chg,(chg+m-1)));
arma::uvec zeros = find(R.rows(chg,(chg+m-1))==0);
int countz=zeros.n_rows;
int counto=ones.n_rows;

//zerosok are the zero position in R that can be candidate for being changed into a one position
arma::uvec zerosok(countz);
zerosok.zeros();
int countzok=0;
for(int j=0; j<countz; j++){
        if(countnotwo[zeros[j]]>selectioncgh){
                     zerosok[countzok]=zeros[j];
                     countzok++;
        }
}
//Put the positions that could be changed into a single vector
arma::uvec posok = arma::join_cols(ones,zerosok);

if(ones.n_rows!=0 || countzok!=0){

//AD step
if(countz==m || countz==0 || x<phi || countzok==0){
          //Select position to be changed
          choice=posok[rand()%(countzok+counto)];
          //Change the value of the selected position
          Rnew[chg+choice]=abs(Rnew[chg+choice]-1);
          //Compute log\pi(Rnew|...)-log\pi(Rold|...)
          piRxi=piRxi+pRAD(choice,chg,m,add0,add1,mGam,mOm1,mOm2,mRnew,mR,mg);
          //Add the log ratio of the likelihoods: log(likelihood|Rnew)- log(likelihood|Rold)      
          piRxi=piRxi+mml(mRnew,mXI,mY,c,d,delta,chg+choice,Hs,nOss,m,g,mg)-mml(mR,mXI,mY,c,d,delta,chg+choice,Hs,nOss,m,g,mg);
}

//Swap step
else{
     //Select positions to be changed
     choice1=zerosok[rand()%(countzok)];
     choice2=ones[rand()%(counto)];
     //Change the value of the selected positions
     Rnew[chg+choice1]=abs(Rnew[chg+choice1]-1);
     Rnew[chg+choice2]=abs(Rnew[chg+choice2]-1);
     flag.zeros();
     //Compute log\pi(Rnew|...)-log\pi(Rold|...)
     piRxi=piRxi+pRS(choice1,chg,m,add0,add1,mGam,mOm1,mOm2,mRnew,mR,mFlag,&flag,mg);
     piRxi=piRxi+pRS(choice2,chg,m,add0,add1,mGam,mOm1,mOm2,mRnew,mR,mFlag,&flag,mg);
     //Add the log ratio of the likelihoods: log(likelihood|Rnew)- log(likelihood|Rold)       
     piRxi=piRxi+mml(mRnew,mXI,mY,c,d,delta,chg+choice1,Hs,nOss,m,g,mg)-mml(mR,mXI,mY,c,d,delta,chg+choice1,Hs,nOss,m,g,mg);
}  
}

//Accept/Reject the proposed value/values
double random=rand()/(double(RAND_MAX)+1); 
double move = (0<piRxi)?0:piRxi;
if(random<exp(move)||move==0){
                              *Rout=Rnew;
                              acc=1;}

return acc;//return one if accepted zero if not (acceptance rate)

}

/*
#############
##MH for xi##
#############
*/


double MHxi(int* mXI,arma::mat A,arma::mat Picum,double* mDist,double disfix,double alpha,double* mGam,double* mOm1,double* mOm2,double* mSum,double e,double f,int* mR,double* mY,double c,double d,double delta,arma::colvec mu,arma::colvec sigma,double* mX,arma::mat tran,arma::colvec Pi,arma::imat *xiout,arma::colvec *gammaout,arma::colvec *omega1out,arma::colvec *omega2out, arma::colvec *sumout,double den,double add0,double add1,arma::mat Hs,int choice,int sel,int m,int mg,int g,int nOss)
{

arma::icolvec R(mR,mg,false);
arma::mat X(mX,nOss,m,false);
arma::colvec gammaold(mGam,m,false);
arma::colvec omega1old(mOm1,m,false);
arma::colvec omega2old(mOm2,m,false);
arma::colvec sumold(mSum,(m+1),false);
arma::imat xi(mXI,nOss,m,false);
arma::colvec distance(mDist,m,false);

arma::imat xinew(nOss,m);
xinew=xi;
int* mXInew=xinew.memptr();

//Proposed xi
double ran;

if (choice==0){
                    ran= rand()/(double(RAND_MAX)+1);
                    if(ran<Picum[0]){xinew(sel,0)=1;}
                    if(Picum[0]<=ran && ran<Picum[1]){xinew(sel,0)=2;}
                    if(Picum[1]<=ran && ran<Picum[2]){xinew(sel,0)=3;}
                    if(ran>Picum[2]){xinew(sel,0)=4;}
}
if(choice!=0){
                 ran= rand()/(double(RAND_MAX)+1);
                 if(ran<A(xi(sel,choice-1)-1,0)){xinew(sel,choice)=1;}
                 if(A(xi(sel,choice-1)-1,0)<=ran && ran<A(xi(sel,choice-1)-1,1)){xinew(sel,choice)=2;}
                 if(A(xi(sel,choice-1)-1,1)<=ran && ran<A(xi(sel,choice-1)-1,2)){xinew(sel,choice)=3;}
                 if(ran>A(xi(sel,choice-1)-1,2)){xinew(sel,choice)=4;}
}
if(xinew(sel,choice)!=xi(sel,choice)){
//Compute new gamma, omega1, omega2
arma::colvec gamma(m);
arma::colvec omega1(m);
arma::colvec omega2(m);
arma::colvec sum(m+1);
sum=sumold;
gamma=gammaold;
omega1=omega1old;
omega2=omega2old;
double* mGamNew=gamma.memptr();
double* mOm1New=omega1.memptr();
double* mOm2New=omega2.memptr();

if(choice>0){
              arma::uvec stemp=find(xinew.col(choice)==xinew.col(choice-1));
              sum[choice]=stemp.n_rows*((exp(1-(distance[choice-1]/disfix))-1)/DEN)/nOss;
}

if(choice<m-1){
               arma::uvec stemp=find(xinew.col(choice)==xinew.col(choice+1));
               sum[choice+1]=stemp.n_rows*((exp(1-(distance[choice]/disfix))-1)/DEN)/nOss;
}

if(choice==0){
gamma[choice]=alpha/(alpha+sum[choice]+sum[choice+1]);
gamma[choice+1]=alpha/(alpha+sum[choice+1]+sum[choice+2]);
omega1[choice+1]=sum[choice+1]/(alpha+sum[choice+1]+sum[choice+2]);
omega2[choice]=sum[choice+1]/(alpha+sum[choice]+sum[choice+1]);
omega2[choice+1]=sum[choice+2]/(alpha+sum[choice+1]+sum[choice+2]);              
}

if(choice==m-1){
gamma[choice]=alpha/(alpha+sum[choice]+sum[choice+1]);
gamma[choice-1]=alpha/(alpha+sum[choice-1]+sum[choice]);
omega1[choice]=sum[choice]/(alpha+sum[choice]+sum[choice+1]);
omega1[choice-1]=sum[choice-1]/(alpha+sum[choice-1]+sum[choice]);
omega2[choice-1]=sum[choice]/(alpha+sum[choice-1]+sum[choice]);              
}

if (choice>0 && choice<m-1){
gamma[choice]=alpha/(alpha+sum[choice]+sum[choice+1]);
gamma[choice-1]=alpha/(alpha+sum[choice-1]+sum[choice]);
gamma[choice+1]=alpha/(alpha+sum[choice+1]+sum[choice+2]);
omega1[choice]=sum[choice]/(alpha+sum[choice]+sum[choice+1]);
omega1[choice-1]=sum[choice-1]/(alpha+sum[choice-1]+sum[choice]);
omega1[choice+1]=sum[choice+1]/(alpha+sum[choice+1]+sum[choice+2]);
omega2[choice]=sum[choice+1]/(alpha+sum[choice]+sum[choice+1]);
omega2[choice-1]=sum[choice]/(alpha+sum[choice-1]+sum[choice]);
omega2[choice+1]=sum[choice+2]/(alpha+sum[choice+1]+sum[choice+2]);
}

//Compute log\pi(R|xinew)-log\pi(R|xiold) and log\pi(Y|xinew)-log\pi(Y|xiold)

double piRxi=0;
double piYxi=0;
int jm;

for (int j = 0; j < g; j++){
    jm=j*m;
    //Compute log(p(R|xinew))-log(p(R|xi))
    piRxi=piRxi+pRXI(choice,jm,m,add0,add1,mGam,mOm1,mOm2,mGamNew,mOm1New,mOm2New,mR,mg);
    //Compute log\pi(Y|xinew)-log\pi(Y|xiold)    
    if(R[jm+choice]==1){piYxi=piYxi+mml(mR,mXInew,mY,c,d,delta,jm+choice,Hs,nOss,m,g,mg)-mml(mR,mXI,mY,c,d,delta,jm+choice,Hs,nOss,m,g,mg);}
}

//Compute log\pi(X|xinew)-log\pi(X|xiold) and log\pi(xinew|xiold)-log\pi(xiold|xinew)

double piXxi=0;
double pixi=0;

//Compute log\pi(X|xinew)-log\pi(X|xiold)
piXxi=piXxi+ldnwpi(X(sel,choice),mu[xinew(sel,choice)-1],sigma[xinew(sel,choice)-1])-ldnwpi(X(sel,choice),mu[xi(sel,choice)-1],sigma[xi(sel,choice)-1]);
//Compute log\pi(xinew|xiold)-log\pi(xiold|xinew)
if(choice<(m-1)){pixi=pixi+log(tran(xinew(sel,choice)-1,xinew(sel,(choice+1))-1))-log(tran(xi(sel,choice)-1,xi(sel,(choice+1))-1));}

//Accept/Reject the proposed value
double pi2=piRxi+piYxi+piXxi+pixi;
double random=rand()/(double(RAND_MAX)+1); 
double move = (0<pi2)?0:pi2;
int acc=0;
if(random<exp(move)||move==0){
	*xiout=xinew;
	*gammaout=gamma;
	*omega1out=omega1;
	*omega2out=omega2;
	*sumout=sum;
	acc=1;
}

return acc;
}
else{
return 0;
}
}

/*
#################################################################################
################################Various functions################################
#################################################################################
*/

/*
###############################
##Probability for single r_gm##
###############################
*/

double pRedge(double gamma, double omega, int rgm, int rgma, double add){
double out=log(add*gamma+((rgm==rgma)?omega:0));
return out;
}

double pRmiddle(double gamma, double omega1, double omega2, int rgm, int rgmm, int rgmp, double add){
double out=log(add*gamma+((rgm==rgmm)?omega1:0)+((rgm==rgmp)?omega2:0));
return out;
}

/*
###############################
##Probability for single r_gm##
###############################
*/

double pr(int choice,int m,int chg,double add0,double add1,double* mGam,double* mOm1,double* mOm2,int* mRnew,int* mR,int mg){
arma::icolvec R(mR,mg,false);
arma::icolvec Rnew(mRnew,mg,false);
arma::colvec gamma(mGam,m,false);
arma::colvec omega1(mOm1,m,false);
arma::colvec omega2(mOm2,m,false);

double out=0;
double add=((R[chg+choice]==0)?add0:add1);
double addnew=((Rnew[chg+choice]==0)?add0:add1);
	if(choice==0){
		out=out+pRedge(gamma[choice],omega2[choice],Rnew[chg+choice],Rnew[chg+choice+1],addnew);
		out=out-pRedge(gamma[choice],omega2[choice],R[chg+choice],R[chg+choice+1],add);
	}
	if(choice==(m-1)){
		out=out+pRedge(gamma[choice],omega1[choice],Rnew[chg+choice],Rnew[chg+choice-1],addnew);
		out=out-pRedge(gamma[choice],omega1[choice],R[chg+choice],R[chg+choice-1],add);
	}
	if(choice>0 && choice<(m-1)){
		out=out+pRmiddle(gamma[choice],omega1[choice],omega2[choice],Rnew[chg+choice],Rnew[chg+choice-1],Rnew[chg+choice+1],addnew);
		out=out-pRmiddle(gamma[choice],omega1[choice],omega2[choice],R[chg+choice],R[chg+choice-1],R[chg+choice+1],add);
	}
return out;
}

double pr2(int choice,int m,int chg,double add,double* mGam,double* mOm1,double* mOm2,double* mGamNew,double* mOm1New,double* mOm2New,int* mR, int mg){
arma::icolvec R(mR,mg,false);
arma::colvec gamma(mGam,m,false);
arma::colvec omega1(mOm1,m,false);
arma::colvec omega2(mOm2,m,false);
arma::colvec gammanew(mGamNew,m,false);
arma::colvec omega1new(mOm1New,m,false);
arma::colvec omega2new(mOm2New,m,false);

double out=0;
	if(choice==0){
		out=out+pRedge(gammanew[choice],omega2new[choice],R[chg+choice],R[chg+choice+1],add);
		out=out-pRedge(gamma[choice],omega2[choice],R[chg+choice],R[chg+choice+1],add);
	}
	if(choice==(m-1)){
		out=out+pRedge(gammanew[choice],omega1new[choice],R[chg+choice],R[chg+choice-1],add);
		out=out-pRedge(gamma[choice],omega1[choice],R[chg+choice],R[chg+choice-1],add);
	}
	if(choice>0 && choice<(m-1)){
		out=out+pRmiddle(gammanew[choice],omega1new[choice],omega2new[choice],R[chg+choice],R[chg+choice-1],R[chg+choice+1],add);
		out=out-pRmiddle(gamma[choice],omega1[choice],omega2[choice],R[chg+choice],R[chg+choice-1],R[chg+choice+1],add);
	}
return out;
}

/*
#######################
##Probaibity for MH R##
#######################
*/

//Add or Delete step
double pRAD (int choice,int chg,int m,double add0,double add1,double* mGam,double* mOm1,double* mOm2,int* mRnew,int* mR,int mg){
double out=0;
int choice1=0;
//rgm
	out=out+pr(choice,m,chg,add0,add1,mGam,mOm1,mOm2,mRnew,mR,mg);
//rg(m-1)
if(choice!=0){
	choice1=choice-1;
	out=out+pr(choice1,m,chg,add0,add1,mGam,mOm1,mOm2,mRnew,mR,mg);
}
//rg(m+1)
if(choice!=(m-2)){
	choice1=choice+1;
	out=out+pr(choice1,m,chg,add0,add1,mGam,mOm1,mOm2,mRnew,mR,mg);
}
return out;
}

//Swap step
double pRS (int choice,int chg,int m,double add0,double add1,double* mGam,double* mOm1,double* mOm2,int* mRnew,int* mR,int* mFlag,arma::ivec *flagp,int mg){
arma::ivec flag(mFlag,mg,false);
double out=0;
int choice1=0;
//rgm
if(flag[chg+choice]!=1){
	flag[chg+choice]=1;
	out=out+pr(choice,m,chg,add0,add1,mGam,mOm1,mOm2,mRnew,mR,mg);
}
//rg(m-1)
if(choice!=0){
	choice1=choice-1;
	if(flag[chg+choice1]!=1){
		flag[chg+choice1]=1;
		out=out+pr(choice1,m,chg,add0,add1,mGam,mOm1,mOm2,mRnew,mR,mg);
	}
}
//rg(m+1)
if(choice!=(m-2)){
	choice1=choice+1;
	if(flag[chg+choice1]!=1){
		flag[chg+choice1]=1;
		out=out+pr(choice1,m,chg,add0,add1,mGam,mOm1,mOm2,mRnew,mR,mg);
	}
}
*flagp=flag;
return out;
}

//Probability for MH xi
double pRXI (int choice,int chg,int m,double add0,double add1,double* mGam,double* mOm1,double* mOm2,double* mGamNew,double* mOm1New,double* mOm2New,int* mR, int mg){
arma::icolvec R(mR,mg,false);
double add=((R[chg+choice]==0)?add0:add1);
double out=0;
int choice1=0;
//rgm
	out=out+pr2(choice,m,chg,add,mGam,mOm1,mOm2,mGamNew,mOm1New,mOm2New,mR,mg);
//rg(m-1)
if(choice!=0){
	choice1=choice-1;
	out=out+pr2(choice1,m,chg,add,mGam,mOm1,mOm2,mGamNew,mOm1New,mOm2New,mR,mg);
}
//rg(m+1)
if(choice!=(m-2)){
	choice1=choice+1;
	out=out+pr2(choice1,m,chg,add,mGam,mOm1,mOm2,mGamNew,mOm1New,mOm2New,mR,mg);
}
return out;
}

/*
##################################################
##Compute the values for omega1 omega2 and gamma##
##################################################
*/
void omegagamma(arma::mat distance,arma::imat xi,double disfix,double alpha,arma::colvec *gammaex,arma::colvec *omega1ex,arma::colvec *omega2ex,arma::colvec *sumex)
{
#define DEN (exp(1)-1)

int nOss=xi.n_rows;
int m=xi.n_cols;

//Calculate the results
arma::colvec gamma(m);
arma::colvec omega1(m);
arma::colvec omega2(m);
arma::colvec sum(m+1);
sum.zeros();
for (int i = 1; i < m; i++){
    arma::uvec stemp=find(xi.col(i)==xi.col(i-1));
    sum[i]=stemp.n_rows*((exp(1-(distance[i-1]/disfix))-1)/DEN)/nOss;
}

for (int i = 0; i < m; i++){
    omega1[i]=sum[i]/(alpha+sum[i]+sum[i+1]);
    omega2[i]=sum[i+1]/(alpha+sum[i]+sum[i+1]);
    gamma[i]=1-(omega1[i]+omega2[i]);
}

*gammaex=gamma;
*omega1ex=omega1;
*omega2ex=omega2;
*sumex=sum;

}

/*
###############################
##Compute marginal likelihood##
###############################
*/

double mml(int* mR,int* mX,double* mY, double c, double d, double delta, int elem,arma::mat Hs,int nOss,int p,int g,int mg) 
{
arma::icolvec R(mR,mg,false);
arma::mat Y(mY,nOss,g,false);
arma::imat X(mX,nOss,p,false);

int ind=(int) floor(elem/p);
double output;

//log-marginal model likelihood of Yi

//step one: Extract the elements of R involved (g-th regression) and compute the number of ones (included regressors)
arma::icolvec RYi=R.subvec(ind*p,(ind+1)*p-1);
int ki=sum(RYi);

//step two: Extract g-th column of Y
arma::colvec Yi=Y.col(ind);

//step three: extract the included columns of X
arma::mat Zi(nOss,ki);
int temp = 0;
arma::mat Ui(ki,ki);
double qi;
//If it is not the null model
if (ki>0){

   for(int i = 0 ; i < p ; i++){
           if(RYi[i]==1){
                  for(int j = 0 ; j < nOss ; j++){
                          Zi(j,temp)=X(j,i);       
                  }
           temp++;
           }    
   }    

//step four: Compute U_g
Ui=(arma::trans(Zi)*Hs*Zi);
for (int i=0; i<ki; i++){
     Ui(i,i) += c;
}

//step five: Compute q_g
qi=arma::as_scalar((arma::trans(Yi)*Hs*Yi)-(arma::trans(Yi)*Hs*Zi*arma::inv(Ui)*arma::trans(Zi)*Hs*Yi));

//step six: Compute likelihood
output=ki*0.5*log(c)-0.5*(log(arma::det(Ui)))-((nOss+delta)*0.5)*log(d+qi);
}
//If there are no regressor included
else{

//step four: Compute U_g=0
//step five: Compute q_g
double qi=arma::as_scalar((arma::trans(Yi)*Hs*Yi));
//step six: Compute likelihood
output=-((nOss+delta)*0.5)*log(d+qi);
}

return output;
}

/*
#################################################
##Compute log pdf of a Normal (without costant)##
#################################################
*/

double ldnwpi(double x, double mean, double sigma) 
{

double out=-(pow((x-mean),2)/(2*pow(sigma,2)))-log(sigma);

return out;

}

/*
################################################################
##Compute the intiaial probabilities given a transition matrix##
################################################################
*/

arma::colvec initial(arma::mat A) 
{

int n=A.n_rows;
arma::rowvec x(n);
x.ones();
arma::mat eye(n,n);
eye.eye();

arma::mat ones(n,n);
ones.ones();

arma::colvec output(n);
output=arma::trans((x)*arma::inv(eye-A+ones));

return output;
}

/*
############################################
##Propose new values for transition matrix##
############################################
*/

arma::rowvec dir(arma::rowvec a)
{

int l=a.n_cols;
arma::rowvec x(l);

GetRNGstate();
for (int i=0;i<l;i++){
x[i]=Rf_rgamma(a[i],1);
}
PutRNGstate();

double sm=sum(x);

return x/sm;
}

/*
##################################
##Sample from a truncated Normal##
##################################
*/
double truncnorm(double mean,double sd,double lower,double upper){

GetRNGstate();
double res= Rf_qnorm5(Rf_pnorm5(lower,mean,sd,1,0)+unif_rand()*(Rf_pnorm5(upper,mean,sd,1,0)-Rf_pnorm5(lower,mean,sd,1,0)),0,1,1,0);
PutRNGstate();

return ((res*sd)+mean);       
       
}

/*
#################################
##Sample from a truncated gamma##
#################################
*/
double truncgamma(double a,double b,double lower){

double low=lower/b;
double x=0;
double u;
double u2;
GetRNGstate();
if(a<1){
x=low+Rf_rexp(1);
u=rand()/(double(RAND_MAX)+1);
while((log(x)+log(u)/(1-a))>log(a)){
                                    x=low+Rf_rexp(1);
                                    u=rand()/(double(RAND_MAX)+1);
}
}

if(a==1){x=low+Rf_rexp(1);}
if(a>1){

     if(low>(a-1)){
          u=Rf_rexp(1);
          u2=Rf_rexp(0.5);
          x=low+u/(1-(a-1)/low);
          while((x/low-1+log(low/x))>(u2/(a-1))){
                  u=Rf_rexp(1);
                  u2=Rf_rexp(1);
                  x=low+u/(1-(a-1)/low);
          }
     }
     if(low<=(a-1)){
          x=Rf_rgamma(a,1);         
          while(x<=low){
                  x=Rf_rgamma(a,1);
          }
     }
     
}
PutRNGstate();
x=x*b;

return (x);
}
